
;======================================================================                
;               z e r o - p a g e   v a r i a b l e s 
;---------------------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;UNUSED          = $02           ;this zeropage memory location is used to parse the CPIO data

TMP_1           = $10           ;a temporary register

ADDRESS         = $11           ;and $12        ;this is a location in the zero-page (normally used for basic, but we are not using basic, so it is safe)
GRAPH_X_L       = $13
GRAPH_X_H       = $14

BMP_ADDR        = $15           
;BMP_ADR+1      = $16
VIDEO_ADDR      = $17  
;VIDEO_ADDR     = $18
COLCNT          = $19
BITCNT          = $20
CNTR            = $21
CNTR2           = $22
CURSOR_X        = $23           ;buffer used for text printing routine
CURSOR_Y        = $24           ;buffer used for text printing routine
CURSOR_ADDR     = $25           ;and 25

COL_PRINT       = $27           ;holds the color of the charaters printed with the PRINT_CHAR routine
COLOR_ADDR      = $28           ;pointer to color memory
;COLOR_ADDR+1   = $29
STR_ADDR        = $2A           ;pointer to string
;STR_ADDR+1     = $2B           ;           

SCROLL_X        = $3C
SCR_TXT_PNTR    = $3D
;SCR_TXT_PNTR+1 = $3E
SCR_ADR_PNTR    = $3F
;SCR_ADR_PNTR+1 = $40

LIGHTGUN_RAW_X          = $41   ;the uncallibrated lightgun position
LIGHTGUN_X_OFFSET       = $42   ;the measured offset of the lightgun
LIGHTGUN_X              = $43   ;the callibrated lightgun position
LIGHTGUN_RAW_Y          = $44   ;the uncallibrated lightgun position
LIGHTGUN_Y_OFFSET       = $45   ;the measured offset of the lightgun
LIGHTGUN_Y              = $46   ;the callibrated lightgun position


CURSOR_X        = $FA   ;buffer used for text printing routine
CURSOR_Y        = $FB   ;buffer used for text printing routine
CHAR_ADDR       = $FC
;CHAR_ADDR+1    = $FD


;======================================================================                
;                          C O N S T A N T S
;======================================================================                
MISS_LIMIT      = 10           ;the max number failed hits + missed moles

SCROLLSCREEN    = 1984         ;first location of the line we want to scroll our text in ($07C0 = first char of last line)

;default positions for the moles


SPRITE_SIZE_X = 24              ;the number of pixels that a sprite is wide
SPRITE_SIZE_Y = 21              ;the number of pixels that a sprite is high

;--

;HITBOXSIZE_X = 25
;HITBOXSIZE_Y = 25

HIT_AREA_LEFT   = 15   ;the number of pixels to the left of the sprite (the total hitting area will be the size of the sprite plus twice this value) 
HIT_AREA_RIGHT  = 15 + SPRITE_SIZE_X

HIT_AREA_TOP    = 10
HIT_AREA_BOTTOM = 10 + SPRITE_SIZE_Y

;--

;These are the absolute starting position of the mole sprites, do not
;change these values without changing the screen that defines the mole-holes
DEFAULT_XM1 = 60        ;default position X direction of mole 1
DEFAULT_YM1 = 52        ;default position Y direction of mole 1

DEFAULT_XM2 = 180       ;default position X direction of mole 2
DEFAULT_YM2 = 92        ;default position Y direction of mole 2

DEFAULT_XM3 = 60        ;default position X direction of mole 3
DEFAULT_YM3 = 132       ;default position Y direction of mole 3

DEFAULT_XM4 = 180       ;default position X direction of mole 4
DEFAULT_YM4 = 172       ;default position Y direction of mole 4

DEFAULT_XM5 = 60        ;default position X direction of mole 5
DEFAULT_YM5 = 212       ;default position Y direction of mole 5
             

;----------------------------------------------------------------------

;COLOR          = $0268         ;current characxter color
;GDCOL          = $0287         ;backgorund color under cursor
BORDER          = $D020         ;bordercolour
BACKGROUND      = $D021         ;background-0
BACKGROUND1     = $D022         ;background-1
BACKGROUND2     = $D023         ;background-2
BACKGROUND3     = $D024         ;background-3
DATAPORTB       = $DC01         ;Data Port B (keyboard, joystick, paddles),:gameport 1        


CHARSCREEN      = $0400         ;location of the character screen memory
COLORSCREEN     = $D800         ;location of the color screen memory (this value cannot be changed)



; BASIC routines
;-----------------------
PRINT          = $AB1E   ;PRINT = Prints a null terminated string to screen whose address is in A/Y  ;call example:         LDA #<_TEXT                ;define the text used LDY #>_TEXT                ;where text is the label to the corresponding text to be printed JSR PRINT                  ;the print routine is called

; KERNAL routines
;-----------------------
ACPTR   = $FFA5
CHKIN   = $FFC6
CHKOUT  = $FFC9
CHRIN   = $FFCF
CHROUT  = $FFD2
CIOUT   = $FFA8
CINT    = $FF81
CLALL   = $FFE7
CLOSE   = $FFC3
CLRCHN  = $FFCC
GETIN   = $FFE4
IOBASE  = $FFF3
IOINIT  = $FF84
LISTEN  = $FFB1
LOAD    = $FFD5
MEMBOT  = $FF9C
MEMTOP  = $FF99
OPEN    = $FFC0
PLOT    = $FFF0
RAMTAS  = $FF87
RDTIM   = $FFDE
READST  = $FFB7
RESTOR  = $FF8A
SAVE    = $FFD8
SCNKEY  = $FF9F
SCREEN  = $FFED
SECOND  = $FF93
SETLFS  = $FFBA
SETMSG  = $FF90
SETNAM  = $FFBD
SETTIM  = $FFDB
SETTMO  = $FFA2
STOP    = $FFE1
TALK    = $FFB4
TKSA    = $FF96
UDTIM   = $FFEA
UNLSN   = $FFAE
UNTLK   = $FFAB
VECTOR  = $FF8D




;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                             BASIC STARTING ROUTINE 
;      now the program will start after typing the command "RUN" within basic (just like a real program)
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
; 10 SYS (4096)
*=$800

        BYTE        $00, $0E, $08, $0A, $00, $9E, $20, $28, $34, $30, $39, $36, $29, $00, $00, $00


;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                         RASTYER INTERRUPT HANDLER
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;Raster interrupt used for sprite multiplexing and SID player

IRQ             SEI                     ;prevent non maskable interrupt      
                INC $D019               ;"acknowledge" the interrupt by clearing the VIC's interrupt flag.

                ;time,counters and sound
                ;.......................                        
IRQ_00          LDA $D012               ;we call the sound related routines on the end of the screen, so that
                CMP #255                ;the SID player does not eat up critical screen time (used for multiplexing or scrolling)
                BNE IRQ_04              ;
              ;INC BORDER              ;extremely usefull for debugging purposes
                JSR SOUNDFX_PLAY        ;call the Sound/FX playing routine
              ;DEC BORDER              ;extremely usefull for debugging purposes

IRQ_01          DEC DEL_01              ;count seconds (... int call are in 1 second)
                BNE IRQ_02              ;
                LDA #50                 ;number of frames/sec
                STA DEL_01              ;
                LDA GAME_TIME           ;
                BEQ IRQ_12              ;
                DEC GAME_TIME           ;

IRQ_02          DEC DEL_00              ;determines the speed of the mole up/down animation
                BNE IRQ_03              ;
                LDA #5  ;1 makes the moles go to fast!!!
                STA DEL_00              ;
                LDA #1                  ;this indicates that the move mole anim can be played for one step
                STA MOVE_MOLE           ;the routine using this variable also needs to clear it
IRQ_03          JMP IRQ_14              ;

IRQ_04          LDA SPR_MULTIPLEXER     ;this flag is used to enable/disable the sprite multiplexer (0=disabled)
                BNE IRQ_10              ;
                JMP IRQ_13              ;go straight to the end, do not handle sprites and only return for music playback in the next frame
             
                ;sprite multiplexer
                ;.......................
IRQ_10          LDX TABLE_PNTR          ;
            ;  STX BORDER              ;extremely usefull for debugging purposes
                LDA RASTER_TABLE_0,X    ;convert using table
                CLC                     ;we need to add 1,because we can't start a sprite on the line that
                ADC #$02                ;is currently displayed,but we can set it to the next line, so it will be shown in this frame
                STA $D003               ;sprite-1 Y-pos
                STA $D005               ;sprite-2 Y-pos
                INC TABLE_PNTR          ;next value from table

                LDX TABLE_PNTR          ;X-position
                LDA RASTER_TABLE_0,X    ;----------
                STA $D002               ;sprite-1 X-pos
                STA $D004               ;sprite-2 X-pos
                INC TABLE_PNTR          ;next value from table

                LDX TABLE_PNTR          ;Sprite pointer
                LDA RASTER_TABLE_0,X    ;--------------
                STA $07F9               ;set pointer for sprite-1
                CLC                     ;we are using 2 sprites on top of eachother, this gives better optical performance
                ADC #1                  ;the sprites that overlap, should be defined directly after eachother in memory
                STA $07FA               ;set pointer for sprite-2
                INC TABLE_PNTR          ;next value from table

                INC TABLE_PNTR          ;next value from table 
                ;(the dummy value, which we discard)
                
IRQ_12          LDX TABLE_PNTR          ;
                LDA RASTER_TABLE_0,X    ;convert using table
                BNE IRQ_14              ;check for the end of the table
IRQ_13          LDA #$00                ;
                STA TABLE_PNTR          ;
                LDA #255                ;
                STA $D012               ;
                JMP IRQ_DONE            ;
IRQ_14          LDX TABLE_PNTR          ;use the Y-position of the sprite for the next raster interrupt
                LDA RASTER_TABLE_0,X    ;convert using table
                STA $D012                       ;Next interrupt to occur at raster line no. ...
                CLI                             ;enable non maskable interrupt

              ;  JMP $EA31                      ;Jump to the beginning KERNAL's standard interrupt service routine.
IRQ_DONE        JMP $EA81                       ;Jump to the end part of KERNAL's standard interrupt service routine we do not need to jump to $EA31, because we allready did this earlier and we do not want to execute the kernal interrupt again because we allraedy did this for this frame.
                                                ;$EA81 restores A,X,Y before RTS

SPR_MULTIPLEXER BYTE $00
DEL_00          BYTE $01
DEL_01          BYTE $01
MOVE_MOLE       BYTE $00
TABLE_PNTR      BYTE $00

RASTER_TABLE_0  ;values are controlled in the main program loop
Y_POS_MOLE_1    BYTE DEFAULT_YM1
X_POS_MOLE_1    BYTE DEFAULT_XM1
SPRITE_PNTR_1   BYTE $00
SPRITE_DUMMY_1  BYTE $00         ;dummy for tablle allignment to a size that is a power of 2

Y_POS_MOLE_2    BYTE DEFAULT_YM2
X_POS_MOLE_2    BYTE DEFAULT_XM2
SPRITE_PNTR_2   BYTE $00
SPRITE_DUMMY_2  BYTE $00

Y_POS_MOLE_3    BYTE DEFAULT_YM3
X_POS_MOLE_3    BYTE DEFAULT_XM3
SPRITE_PNTR_3   BYTE $00
SPRITE_DUMMY_3  BYTE $00

Y_POS_MOLE_4    BYTE DEFAULT_YM4
X_POS_MOLE_4    BYTE DEFAULT_XM4
SPRITE_PNTR_4   BYTE $00
SPRITE_DUMMY_4  BYTE $00

Y_POS_MOLE_5    BYTE DEFAULT_YM5
X_POS_MOLE_5    BYTE DEFAULT_XM5
SPRITE_PNTR_5   BYTE $00
SPRITE_DUMMY_5  BYTE $00

                BYTE 0          ;end of table  

